// Removing possible garbage objects each 10 minutes
// Detect how many actors exist in Level marked for deletion

class Garb expands Actor;

var int TimeLeft, TheStart;
var bool bSpeedUp, bXCLoaded;
var float F[2], Time;

event PostBeginPlay()
{
	TimeLeft = RandRange(20,30)*60;
	SetTimer( Level.TimeDilation,True);
	log ("Spawned"@Self@"for removing garbage in next"@TimeLeft/60@"minutes.");
	HuntAClock();
}

function HuntAClock()
{
	local int XCC;

	XCC=int(ConsoleCommand("GET INI:ENGINE.ENGINE.GAMEENGINE XC_CORE_VERSION"));
	if (XCC >= 5)
	{
		log (Self.Name@">> found available XC_Core clocking system V"$XCC);
		bXCLoaded=True;
	}
	else
		log (Self.Name@">> did not find valid clocking stuff available.");
}

event Timer()
{
	if ( TheStart < 8 )
	{
		TheStart++;
		return;
	}
	if ( Level.Game != None && (Level.Game).bGameEnded )
	{
		log ("GARB signal: Game has been ended during this hit, quiting...");
		Destroy();
		return;
	}
	TimeLeft--;
	if ( Level.Game.NumPlayers == 0 )
	{
		if (!bSpeedUp)
		{
			bSpeedUp=True;
			TimeLeft=TimeLeft/3;
			log (Self.Name@"> Server looks empty. Purging interval has been changed to"@TimeLeft/60@"minutes.");
		}
//		TimeLeft -= 5; //Accelerate when empty
	}
	else
	{
		if (bSpeedUp)
		{
			bSpeedUp=False;
			TimeLeft=TimeLeft*3;
			log (Self.Name@"> Server has"@Level.Game.NumPlayers@"players. Purging interval has been changed to"@TimeLeft/60@"minutes.");
		}
	}
	if ( TimeLeft <= 0 )
	{
		if (bXCLoaded)
			Clock( F);
				DoPurgeGarbage();
		if (bXCLoaded)
		{
			Time=UnClock( F);
			log (Self.Name@"> worked"@Time@"seconds for removing garbage objects.");
			log ("Finished at "$GetAbsoluteTime());
		}
	}
}

function DoPurgeGarbage()
{
		log (Self.Name@" >> Cleaning garbage objects!");
		ConsoleCommand("OBJ GARBAGE");
		ConsoleCommand("FLUSH");
		TimeLeft = RandRange(20,30)*60;
		log ("Next round after"@TimeLeft/60@"minutes.");
}

function string GetAbsoluteTime()
{
	local string AbsoluteTime;
	local string GMTRef;

	AbsoluteTime = string(Level.Year);

	if (Level.Month < 10)
		AbsoluteTime = AbsoluteTime$"/0"$Level.Month;
	else
		AbsoluteTime = AbsoluteTime$"/"$Level.Month;

	if (Level.Day < 10)
		AbsoluteTime = AbsoluteTime$"/0"$Level.Day;
	else
		AbsoluteTime = AbsoluteTime$"/"$Level.Day;

	if (Level.Hour < 10)
		AbsoluteTime = AbsoluteTime$" Time > 0"$Level.Hour;
	else
		AbsoluteTime = AbsoluteTime$" Time > "$Level.Hour;

	if (Level.Minute < 10)
		AbsoluteTime = AbsoluteTime$":0"$Level.Minute;
	else
		AbsoluteTime = AbsoluteTime$":"$Level.Minute;

	if (Level.Second < 10)
		AbsoluteTime = AbsoluteTime$":0"$Level.Second;
	else
		AbsoluteTime = AbsoluteTime$":"$Level.Second;

	if (Level.Millisecond < 10)
		AbsoluteTime = AbsoluteTime$".0"$Level.Millisecond;
	else
		AbsoluteTime = AbsoluteTime$"."$Level.Millisecond;
	return AbsoluteTime;
}

native (3556) static final function Clock( out float C[2]);
native (3557) static final function float UnClock( out float C[2]);

defaultproperties
{
     RemoteRole=ROLE_None
     NetPriority=1.000000
     NetUpdateFrequency=10.000000
}